Subject: [Sigtran] Number of streams in SCTP Association

From: aditi someshwar <[email-masked]>
Date: Mon, 20 Jun 2011 19:00:52 +0530

Dear all,

Need one clarification please:

NUMBER OF STREAMS WITHIN AN SCTP ASSOCIATION - In quite a few RFCs, it is
mentioned that the NUMBER OF STREAMS within one SCTP Association can be USER
DEFINED, & that the two end-nodes NEGOTIATE these at the time "Association
Set Up". However, REPEATEDLY, these RFCs also suggest that STREAM 0 shall be
used for interchange of CONTROL MESSAGES while STREAM 1 (Note: They call it
STREAM-1, & NOT "other than Stream 0") carries Data.

It is NOT very clear if the RFCs THEMSELVES are specifying / suggesting that
AT MAX, there should be ONLY TWO STREAMs OR is it more a DEFAULT by most
PRODUCT MANUFACTURERS who have (to keep matters less complex) decided to
IMPLEMENT only TWO STREAMS.

Thanks and Regards,

Aditi

---

From: Chris Benson <[email-masked]>
Date: Mon, 20 Jun 2011 14:18:51 -0700 (PDT)

Aditi,

The first sentence in your email content is correct.
The number of streams in an SCTP association is determined
(negotiated) by the two end-point SCTP users.  A specific
implementation of SCTP may restrict the maximum number of 
streams that it can support, but that number will typically
be MUCH greater than 2 streams in each direction.

One example SCTP-user is M3UA, and its RFC 4666 states in
Section 1.4.7. SCTP Stream Mapping:
   1. The DATA message MUST NOT be sent on stream 0.
   2. The ASPSM, MGMT, RKM classes SHOULD be sent on stream 0 
      (other than BEAT, BEAT ACK and NTFY messages).
   3. The SSNM, ASPTM classes and BEAT, BEAT ACK and NTFY 
      messages can be sent on any stream.

The existence of the MUST NOT words in point 1. means that 
M3UA requires SCTP to support two streams in each direction, 
and it would like quite a few more.

Note that in my example the "user" that decides and negotiates
the number of streams is M3UA (the user of SCTP), and not a
human user.

Typically, SCTP-user protocols might expect that considerably 
more than two SCTP streams will be available if requested.

With thanks, from Chris Benson.

On Mon, 20 Jun 2011, aditi someshwar wrote:

>>  Date: Mon, 20 Jun 2011 19:00:52 +0530
>>  From: aditi someshwar <[email-masked]>
>>  To:  <[email-masked]>
>>  Subject: [Sigtran] Number of streams in SCTP Association
>>  
>>  Dear all,
>>  
>>

---

From: aditi someshwar <[email-masked]>
Date: Tue, 21 Jun 2011 09:29:53 +0530

Thanks Chris, Thanks Padmalochan.

Would the M2PA also use more than 2 streams, or is there a restriction
there?

Regards,
Aditi

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Tue, 21 Jun 2011 20:00:38 -0600

aditi,

RFC 4165/Page 24:

 The association SHALL contain two sttreams in each direction.  Stream
 0 is designated for Link Status messages.  Stream 1 is designated for
 User Data messages, as well as Link Status messages that must remain
 in sequence with the User Data messages.

It goes on to say which messages are send on which stream.

--brian

aditi someshwar wrote:               (Tue, 21 Jun 2011 09:29:53)

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/